#include <EEPROM.h>

//LET OP, na schrijven worden de wijzigingen bij een ESP32
//        pas na een EEpromcommit aangebracht.  
#ifdef AVR
int EEpromlength(){         //werkt alleen bij Arduino
 return EEPROM.length();  
}
#endif
#ifdef ESP8266
int EEpromlength(){         //werkt bij ESP12 
 return SPI_FLASH_SEC_SIZE;
}  
#endif
#ifdef ESP32
int EEpromlength(){         //Vaste waarde ESSP32 
 return 4096;
}  
#endif


void EEprombegin(int aantbytes){
#ifdef ESP32
 EEPROM.begin(aantbytes);  //bij ESP32 gebruikte lengte
#endif                     //handmatig opgeven
#ifdef ESP8266
 EEPROM.begin(aantbytes);  //bij ESP12 gebruikte lengte
#endif                     //handmatig opgeven
#ifdef AVR
 EEPROM.begin();           //bij ARD lengte automatisch maximum
#endif    
}
void EEpromreadByte(int adres, byte &databyte){
 databyte = EEPROM.read(adres);      
}

void EEpromreadInt(int adres, int &dataint){
  int i2 = EEPROM.read(adres);    //low order
  int i1 = EEPROM.read(adres + 1);
  dataint = ((i2 << 0) & 0xFF) + ((i1 << 8) & 0xFFFF);
}

void EEpromreadLong(int adres, long &datalong){
 long l4 = EEPROM.read(adres);
 long l3 = EEPROM.read(adres + 1);
 long l2 = EEPROM.read(adres + 2);
 long l1 = EEPROM.read(adres + 3);
 datalong = ((l4 << 0) & 0xFF) + ((l3 << 8) & 0xFFFF)
          + ((l2 << 16) & 0xFFFFFF) + ((l1 << 24) & 0xFFFFFFFF);        
}
  
void EEpromwriteByte(int adres, byte databyte){
 EEPROM.write(adres, databyte);      
}

void EEpromwriteInt(int adres, int dataint){
 byte b2 = (dataint & 0xFF);         //low order
 byte b1 = ((dataint >> 8) & 0xFF);
 EEPROM.write(adres, b2);  //low order (big endian)
 EEPROM.write(adres + 1, b1);
}

void EEpromwriteLong(int adres, long datalong){
 byte b4 = (datalong & 0xFF);        //low order
 byte b3 = ((datalong >> 8) & 0xFF);
 byte b2 = ((datalong >> 16) & 0xFF);
 byte b1 = ((datalong >> 24) & 0xFF); //high order
 EEPROM.write(adres, b4);  //low order (big endian)
 EEPROM.write(adres + 1, b3);
 EEPROM.write(adres + 2, b2);
 EEPROM.write(adres + 3, b1);
}
#ifdef ESP32
void EEpromcommit(){    //pas na een commit worden de wijzigingen
 EEPROM.commit();        //daadwerkelijk aangebracht
}
#endif
#ifdef AVR
void EEpromcommit(){    //pas na een commit worden de wijzigingen
 //geen actie oor Arduino 
}
#endif

#ifdef ESP8266
void EEpromcommit(){    //pas na een commit worden de wijzigingen
 EEPROM.commit();        //daadwerkelijk aangebracht
}
#endif
