#ifdef LCD4regels
 #define LCDI2C
#endif
#ifdef LCD2regels
 #define LCDI2C
#endif
#ifdef LCD2regelsSTD
 #define LCDnoI2C
#endif

//                 Scherm zonder I2C module
#ifdef LCDnoI2C

#include <LiquidCrystal.h>
LiquidCrystal lcd (LCD12, LCD11, LCD5, LCD4, LCD3, LCD2);
                 //pinnumers op LCDdisplay  
int     LCDswopen = 0;

//NB: LCDxx moet met #define opgegeven worden.

void LCDinit() {
 lcd.begin (16, 2);           //2 regels van 16
 lcd.clear ();
 LCDswopen = 1;
}

void LCDclear(){
 lcd.clear();
}

void LCDbacklight(){        //niet aanwezig in deze library
}
void LCDnobacklight(){      //niet aanwezig in deze library
}

void LCDdisplayregel(String tekst,int line, int col){
 // line is 0 tm 1
 // de eerste positie op de regel is 0
 if (LCDswopen == 0){return;}
 lcd.setCursor(col,line);
 lcd.print(tekst);
}
#endif


//             Scherm met I2C module
#ifdef LCDI2C
#include <LiquidCrystal_I2C.h>  
#ifdef LCD4regels
 LiquidCrystal_I2C lcd(0x27,20,4);  // adres 0x27 20 char, 4 regels
 #define LCDI2C
#endif
#ifdef LCD2regels
 LiquidCrystal_I2C lcd(0x27,16,2);  // adres 0x27 16 char, 2 regels
 #define LCDI2C
#endif
String  LCDregel[4];               // 4 regels buffer tbv scroll
int     LCDswopen = 0;

void LCDinit(){
 LCDstatus = 0;
 // eenmalig uitvoeren in setup
 LCDswopen = 0;
 Wire.begin();                        //open Wire commmunicatie
 Wire.beginTransmission(0x27);        //start communicatie met LCD (adr27)
 LCDstatus = Wire.endTransmission();  //stop commnicatie
 if (LCDstatus == 0){
  LCDswopen = 1;
 }else{
  return;
 }
 lcd.init();         //Init LCD
 //lcd.begin(21, 22);
 lcd.clear();        //wis schrm
 lcd.noBacklight();  //geen backlight
}
void LCDclear(){
 lcd.clear();
 LCDregel[0] = "" ;
 LCDregel[1] = "" ;
 LCDregel[2] = "" ;
 LCDregel[3] = "" ;  
}
void LCDbacklight(){
 lcd.backlight();
}
void LCDnobacklight(){
 lcd.noBacklight();
}
void LCDdisplayregel(String tekst,int line, int col){
 // line is 0 tm 3
 // de eerste positie op de regel is 0
 String regel = "";
 if (LCDswopen == 0){return;}
 lcd.setCursor(col,line);
 lcd.print(tekst);
 regel = LCDregel[line].substring(0,col);
 regel += tekst;
 regel += LCDregel[line].substring(regel.length());
 LCDregel[line] = regel;     //bewaar line voor latere scrolls
} 
#ifdef LCD4regels
void LCDscrollendisplayregel(String tekst,int col){
 // lines 2 tm 4 worden omhoog geschoven
 // de tekst wordt op regel 4 gezet
 if (LCDswopen == 0){ return;}
 lcd.clear();
 LCDregel[0] = LCDregel[1]; //scroll de opgeborgen regels
 LCDregel[1] = LCDregel[2];
 LCDregel[2] = LCDregel[3];
 lcd.setCursor(0,0);        //scroll regels 4, 3 en 1 omhoog
 lcd.print(LCDregel[0]);
 lcd.setCursor(0,1);
 lcd.print(LCDregel[1]);
 lcd.setCursor(0,2);
 lcd.print(LCDregel[2]);
 lcd.setCursor(col,3);
 lcd.print(tekst);          //plaats tekst op onderste regel
 LCDregel[3] = tekst;
}
#endif
#ifdef LCD2regels
void LCDscrollendisplayregel(String tekst,int col){
 // line 1 wordt omhoog geschoven
 // de tekst wordt op regel 1 gezet
 if (LCDswopen == 0){ return;}
 lcd.clear();
 LCDregel[0] = LCDregel[1]; //scroll de opgeborgen regels
 lcd.setCursor(0,0);        //scroll regel 1 omhoog
 lcd.print(LCDregel[0]);
 lcd.setCursor(col,1);
 lcd.print(tekst);          //plaats tekst op onderste regel
 LCDregel[1] = tekst;
}
#endif
#endif  // LCDI2C