//*******************************************************
// Print midifile
//****************************************************

long  MidiPrtfilesize = 0;       //lengte op disk
int   MidiPrtformat = 0;         //0 (alleen trk 0), 1(trk0 en trk1,2 etc)
int   MidiPrtticksperkwart = 48; //default
int   MidiPrtstatus = 0;         //0 file not open
                              //1 = midifile OK
                              //2 = geen MTrk (format eror)
                              //3 = geen fmt0 of 1
                              //5 = EOF
                              //7 = structuur-error
                              //8 = file open error
long  MidiPrttempo = 500000;     //mm120 bij 120 ticksperkwart
int   MidiPrtaanttracks = 0;     //1 bij fmt0, min 2 bij fmt1
float MidiPrtmspertick = 10.4;   //=tempo/1000/ticksperkwart
byte  MidiPrtlastevent = 0;      //tbv running status
long  MidiPrttrackleng[32] ;     //exclusief MTrk en llll
long  MidiPrttrackadres[32];     //begin position in file
long  MidiPrteventnr[32];        //eventnr binnen track

void MidiOpenfileprintSD(String filenaam){
 // Open midifile
 String filenm = "/"+ filenaam;
 String trackhead = ""; 
 char   inchar ;
 long   trackadres = 0;
 MidiPrtstatus = 0;
 SDopenfileread(0,filenm);
 if (SDfilestatus[0] != 1) {  
  MidiPrtstatus = 8;
  return;
 }
 MidiPrtfilesize =  SDfilesize(0);
 SDseek(0,14);   //MTrk
 for (int i = 0;i<4;i++){ 
  SDreadChar(0,inchar);
  trackhead += inchar;
 }
 if (trackhead != "MTrk") {
  MidiPrtstatus = 2;          //geen trackheader, geen midi
  return;
 }  
 SDseek(0,8);              //format 
 SDreadIntDOS(0,MidiPrtformat);
 SDseek(0,10);            //aantal tracks 
 SDreadIntDOS(0,MidiPrtaanttracks);
 if ((MidiPrtformat != 0) && (MidiPrtformat != 1)){
  MidiPrtstatus = 3;         //geen format 0 of  1
  return;  
 }    
 SDseek(0,12);            //ticksperkwart 
 SDreadIntDOS(0,MidiPrtticksperkwart);
 trackadres = 14;         //eerste track, vast adres
 for (int t=0;t<MidiPrtaanttracks;t++){
  MidiPrttrackadres[t] = trackadres; 
  MidiPrteventnr[t] = 0;
  SDseek(0,trackadres);    //positioneer op track
  trackhead = "";
  for (int i=0;i<4;i++){   //MTrk
   SDreadChar(0,inchar);
   trackhead += inchar;
  }
  if (trackhead != "MTrk") {
   MidiPrtstatus = 2;         //volgend track geen trackheader
   return;
  }else{
   SDreadLongDOS(0,MidiPrttrackleng[t]);
  }  
  trackadres += (MidiPrttrackleng[t]);  //volgende track
  trackadres += 8;  //lengte is excl MTrk en lengteveld
 } 
 MidiPrtstatus = 1; 
}

void MidiReadeventprintSD(int tracknr, long &delta,byte &event, 
                      byte &subevent, byte &data1, byte &data2,
                      String &mididata){
                      //format 0 alleen track 1
                      //format 1, track0, track 1 etc  
// Lees midi-event
 String record = "";
 char   inchar;
 byte   inbyte; 
 long   inlong = 0;
 byte   eventkaal = 0;
 byte   byte1 = 0;
 subevent = 0;
 data1 = 0;
 data2 = 0;
 mididata = "";
 if (MidiPrteventnr[tracknr] == 0){         //begin van track
  MidiPrteventnr[tracknr] = 1;
  SDseek(0, MidiPrttrackadres[tracknr]+8 ); //passeer MTrk en lengte
  MidiPrtstatus = 1;
 } 
 delta = 0;
 SDreadByte(0,inbyte);     //lees deltatime 1 tot 4 bytes (mod128)
 if (inbyte < 128){
  delta = delta + inbyte;     //1e byte, klaar
 }else{
  delta = delta + (inbyte -128);
  delta = delta * 128; 
  SDreadByte(0, inbyte);
  if (inbyte < 128){
   delta = delta + inbyte;    //2e byte, klaar
  }else{
   delta = delta + (inbyte -128);
   delta = delta * 128; 
   SDreadByte(0, inbyte);
   if (inbyte < 128){
    delta = delta + inbyte;   //3e byte, klaar
   }else{
    delta = delta + (inbyte -128);
    delta = delta * 128; 
    SDreadByte(0, inbyte);
    if (delta < 128){         //4e moet laag zijn
     delta = delta + inbyte;  //4e byte, klaar
    }else{
     MidiPrtstatus = 7;          //structuur error
    }
   }
  }
 }  //delta ingelezen 
 SDreadByte(0, inbyte);       //eventbyte of running
 if (inbyte < 128){           //running status
  byte1 = inbyte;             //byte 1 van message
  event = MidiPrtlastevent;      //gebruik vorige event
 }else{
  event = inbyte;             //event ingelezen
  MidiPrtlastevent = event;      //save voor running status
  SDreadByte(0, byte1);       //lees byte 1 van message
 }
 if (event == 255){           //hex FF, meta-event 
  subevent = byte1;           //byte1 is metadatacode 
  if (subevent == 0x2F){      //EOT
   MidiPrtstatus = 5;            //end of track
   return;
  } 
  if (subevent == 0x51){      //tempo
   mididata = "tempo"; 
   SDreadByte(0, inbyte);     //lengteveld
   SDreadByte(0, inbyte);     //3bytes tempo (little endian)
   MidiPrttempo = inbyte*pow(256,2);
   SDreadByte(0, inbyte);
   inlong = inbyte*256;
   MidiPrttempo += inlong; 
   SDreadByte(0, inbyte);
   MidiPrttempo += inbyte;
   MidiPrtmspertick = MidiPrttempo / 1000 / MidiPrtticksperkwart; 
   return;
  } 
  if (subevent == 0x58){      //time signature
   mididata = "time signature"; 
   SDreadByte(0, inbyte);     //lengteveld
   SDreadByte(0, inbyte);     //4bytes signature
   SDreadByte(0, inbyte);
   SDreadByte(0, inbyte);
   SDreadByte(0, inbyte);
   return;
  } 
  if (subevent == 0x59){      //key signature
   mididata = "key signature"; 
   SDreadByte(0, inbyte);     //lengteveld
   SDreadByte(0, inbyte);     //2bytes signature
   SDreadByte(0, inbyte);
   return;
  } 
  if ((subevent > 0) & (subevent < 10)){ //string event 01 tm 09
   SDreadByte(0, inbyte);      //inbyte is lengteveld  
   for (int j = inbyte;j>0;j--){ 
    SDreadChar(0, inchar);     //string 
    mididata += inchar;
   } 
   return;
  }else{
   SDreadByte(0, inbyte);         //lengteveld  
   for (int k = inbyte;k>0;k--){  //byte1 is lengteveld
    SDreadChar(0,inchar);         //skip data 
   } 
   return; 
  }  
 }else{                        //non meta-events
  eventkaal = event & 0xF0;    //verwijder channel
  switch (eventkaal){
  case 0x80:            //noteoff
   data1 = byte1;       //al ingelezen
   SDreadByte(0, data2);  
   return;
  case 0x90:            //noteon of noteoff
   data1 = byte1;       //al ingelezen
   SDreadByte(0, data2);  
   return; 
  case 0xA0:             //polyphone aftertouch
   mididata = "polyphone aftertouch"; 
   data1 = byte1;        //al ingelezen
   SDreadByte(0, data2); 
   return;
  case 0xB0:             //control change
   mididata = "control change"; 
   data1 = byte1;        //al ingelezen
   SDreadByte(0, data2); 
   return;
  case 0xC0:             //program change
   mididata = "program change"; 
   data1 = byte1;        //al ingelezen
   break;
  case 0xD0:             //channel aftertouch
   mididata = "channel aftertouch"; 
   data1 = byte1;        //al ingelezen
   return;
  case 0xE0:             //pitch bend
   mididata = "pich bend"; 
   data1 = byte1;        //al ingelezen
   SDreadByte(0, data2); 
   return;
  } 
  if (event == 0xF0){    //sysex
   mididata = "Sysex"; 
   inbyte = data1;       //al ingelezen
   while (true){
    if (inbyte == 0xF7){
     return;
    }
    SDreadByte(0, inbyte);   //skip alle data 
   }
   if ((event == 0xF1) | (event == 0xF3)){
    //                    //geen data
    return;
   }
    if ((event == 0xF2) | (event == 0xF30)){
    //                    //data1 al ingelezen, skip
    SDreadByte(0, inbyte);   //skip data2
    return;
   }
  } 
 }
}                                  


void PrintmidifileSD(String filenaam, String(swnotes)){ 
 long delta = 0;
 byte event = 0;
 byte subevent = 0;
 byte data1 = 0;  
 byte data2 = 0;
 String mididata = "";
 byte eventkaal = 0;
 long noteons = 0;
 long noteoffs = 0;
 long deltatot = 0;
 MidiOpenfileprintSD(filenaam);
 Serial.print(filenaam);
 if (MidiPrtstatus == 8) {
  Serial.println(", file open error");
  return;
 } 
 Serial.println(", file size: " + String(MidiPrtfilesize));
 if (MidiPrtstatus == 2) {
  Serial.println("Geen MidiPrt-file");
  return;
 } 
 if (MidiPrtstatus == 3) {
  Serial.println("Geen format 0 of 1");
  return;
 } 
 Serial.println("Format: " + String(MidiPrtformat));
 Serial.println("Aantal tracks: "+ String(MidiPrtaanttracks)); 
 Serial.println("Ticksperkwart "+ String(MidiPrtticksperkwart));    
 for (int t=0;t<MidiPrtaanttracks;t++){
  Serial.println("track"+ String(t) + " "+ MidiPrttrackleng[t]); 
 }
 for(int trk=0;trk<MidiPrtaanttracks;trk++){ 
  Serial.println("Start track "+ String(trk) 
                 + " lengte "+ String(MidiPrttrackleng[trk]));
  noteons = 0;
  noteoffs = 0;
  deltatot = 0; 
 while (true){
  MidiReadeventprintSD(trk,delta,event,subevent, data1,data2, mididata);
  if (MidiPrtstatus == 5){
   Serial.print("noteons " + String(noteons)); 
   Serial.print ("  noteoffs " + String(noteoffs)); 
   Serial.println (" ticks " + String(deltatot)); 
   Serial.println("End of track "+ String(trk));
   break;    
  }
  if (MidiPrtstatus == 7){
   Serial.println("Stuctuurfout in bestand"); 
   return;    
  }
  deltatot += delta;
  eventkaal = event & 0XF0;
  if ((event == 0xFF) & (subevent == 0x2F)){   //EOT
   break; 
  }
   if (eventkaal == 0x80){
   if (swnotes == "1") {
    Serial.println("noteoff "+ String(data1) + ","+ String(delta));
   }
   noteoffs++;
   goto nextevent;
  }
  if (eventkaal == 0x90){
   if (data2 == 0){
    if (swnotes == "1") {
     Serial.println("noteoff "+ String(data1) + ","+ String(delta)); 
    } 
    noteoffs++;
   }else{
    if (swnotes == "1") {
     Serial.println("noteon "+ String(data1) + ","+ String(delta)); 
    } 
    noteons++;
    }
    goto nextevent;
   }  
   Serial.print(event,HEX);
   if ((event == 0xFF) & (subevent != 0)){
    if (subevent < 16){
     Serial.print("0");  //voorloop 0
    }
    Serial.print(subevent,HEX);
    Serial.print(" "+ mididata);
    if (subevent == 0x51){
     Serial.print(" "+ String(MidiPrttempo));
     Serial.println(", mspertick "+ String(MidiPrtmspertick));
    }else{ 
     Serial.println();
    }
   }else{
    Serial.println(" "+ mididata);
   }
nextevent: 
 data1 = data1;  //dummy instructie tbv label
 } //end while
} //end for
 
 SDclosefile(1);
}
                                         
