#ifndef ESP32
 FOUT alleen voor ESP32
#endif

//*******************************************************
// Print midifile
//****************************************************

long  MidiPrtSPfilesize = 0;       //lengte op disk
int   MidiPrtSPformat = 0;         //0 (alleen trk 0), 1(trk0 en trk1,2 etc)
int   MidiPrtSPticksperkwart = 48; //default
int   MidiPrtSPstatus = 0;         //0 file not open
                              //1 = midifile OK
                              //2 = geen MTrk (format eror)
                              //3 = geen fmt0 of 1
                              //5 = EOF
                              //7 = structuur-error
                              //8 = file open error
long  MidiPrtSPtempo = 500000;     //mm120 bij 120 ticksperkwart
int   MidiPrtSPaanttracks = 0;     //1 bij fmt0, min 2 bij fmt1
float MidiPrtSPmspertick = 10.4;   //=tempo/1000/ticksperkwart
byte  MidiPrtSPlastevent = 0;      //tbv running status
long  MidiPrtSPtrackleng[32] ;     //exclusief MTrk en llll
long  MidiPrtSPtrackadres[32];     //begin position in file
long  MidiPrtSPeventnr[32];        //eventnr binnen track

void MidiOpenfileprintSP(String filenaam){
 // Open midifile
 //String filenm = "/"+ filenaam;
 String filenm = filenaam;
 String trackhead = ""; 
 char   inchar ;
 long   trackadres = 0;
 MidiPrtSPstatus = 0;
 SPopenfileread(filenm);
 if (SPfilestatus != 1) {  
  MidiPrtSPstatus = 8;
  return;
 }
 MidiPrtSPfilesize =  SPfilesize();
 SPseek(14);   //MTrk
 for (int i = 0;i<4;i++){ 
  SPreadChar(inchar);
  trackhead += inchar;
 }
 if (trackhead != "MTrk") {
  MidiPrtSPstatus = 2;          //geen trackheader, geen midi
  return;
 }  
 SPseek(8);              //format 
 SPreadIntDOS(MidiPrtSPformat);
 SPseek(10);            //aantal tracks 
 SPreadIntDOS(MidiPrtSPaanttracks);
 if ((MidiPrtSPformat != 0) && (MidiPrtSPformat != 1)){
  MidiPrtSPstatus = 3;         //geen format 0 of  1
  return;  
 }    
 SPseek(12);            //ticksperkwart 
 SPreadIntDOS(MidiPrtSPticksperkwart);
 trackadres = 14;         //eerste track, vast adres
 for (int t=0;t<MidiPrtSPaanttracks;t++){
  MidiPrtSPtrackadres[t] = trackadres; 
  MidiPrtSPeventnr[t] = 0;
  SPseek(trackadres);    //positioneer op track
  trackhead = "";
  for (int i=0;i<4;i++){   //MTrk
   SPreadChar(inchar);
   trackhead += inchar;
  }
  if (trackhead != "MTrk") {
   MidiPrtSPstatus = 2;         //volgend track geen trackheader
   return;
  }else{
   SPreadLongDOS(MidiPrtSPtrackleng[t]);
  }  
  trackadres += (MidiPrtSPtrackleng[t]);  //volgende track
  trackadres += 8;  //lengte is excl MTrk en lengteveld
 } 
 MidiPrtSPstatus = 1; 
}

void MidiReadeventprintSP(int tracknr, long &delta,byte &event, 
                      byte &subevent, byte &data1, byte &data2,
                      String &mididata){
                      //format 0 alleen track 1
                      //format 1, track0, track 1 etc  
// Lees midi-event
 String record = "";
 char   inchar;
 byte   inbyte; 
 long   inlong = 0;
 byte   eventkaal = 0;
 byte   byte1 = 0;
 subevent = 0;
 data1 = 0;
 data2 = 0;
 mididata = "";
 if (MidiPrtSPeventnr[tracknr] == 0){         //begin van track
  MidiPrtSPeventnr[tracknr] = 1;
  SPseek( MidiPrtSPtrackadres[tracknr]+8 ); //passeer MTrk en lengte
  MidiPrtSPstatus = 1;
 } 
 delta = 0;
 SPreadByte(inbyte);     //lees deltatime 1 tot 4 bytes (mod128)
 if (inbyte < 128){
  delta = delta + inbyte;     //1e byte, klaar
 }else{
  delta = delta + (inbyte -128);
  delta = delta * 128; 
  SPreadByte( inbyte);
  if (inbyte < 128){
   delta = delta + inbyte;    //2e byte, klaar
  }else{
   delta = delta + (inbyte -128);
   delta = delta * 128; 
   SPreadByte( inbyte);
   if (inbyte < 128){
    delta = delta + inbyte;   //3e byte, klaar
   }else{
    delta = delta + (inbyte -128);
    delta = delta * 128; 
    SPreadByte( inbyte);
    if (delta < 128){         //4e moet laag zijn
     delta = delta + inbyte;  //4e byte, klaar
    }else{
     MidiPrtSPstatus = 7;          //structuur error
    }
   }
  }
 }  //delta ingelezen 
 SPreadByte( inbyte);       //eventbyte of running
 if (inbyte < 128){           //running status
  byte1 = inbyte;             //byte 1 van message
  event = MidiPrtSPlastevent;      //gebruik vorige event
 }else{
  event = inbyte;             //event ingelezen
  MidiPrtSPlastevent = event;      //save voor running status
  SPreadByte( byte1);       //lees byte 1 van message
 }
 if (event == 255){           //hex FF, meta-event 
  subevent = byte1;           //byte1 is metadatacode 
  if (subevent == 0x2F){      //EOT
   MidiPrtSPstatus = 5;            //end of track
   return;
  } 
  if (subevent == 0x51){      //tempo
   mididata = "tempo"; 
   SPreadByte( inbyte);     //lengteveld
   SPreadByte( inbyte);     //3bytes tempo (little endian)
   MidiPrtSPtempo = inbyte*pow(256,2);
   SPreadByte( inbyte);
   inlong = inbyte*256;
   MidiPrtSPtempo += inlong; 
   SPreadByte( inbyte);
   MidiPrtSPtempo += inbyte;
   MidiPrtSPmspertick = MidiPrtSPtempo / 1000 / MidiPrtSPticksperkwart; 
   return;
  } 
  if (subevent == 0x58){      //time signature
   mididata = "time signature"; 
   SPreadByte( inbyte);     //lengteveld
   SPreadByte( inbyte);     //4bytes signature
   SPreadByte( inbyte);
   SPreadByte( inbyte);
   SPreadByte( inbyte);
   return;
  } 
  if (subevent == 0x59){      //key signature
   mididata = "key signature"; 
   SPreadByte( inbyte);     //lengteveld
   SPreadByte( inbyte);     //2bytes signature
   SPreadByte( inbyte);
   return;
  } 
  if ((subevent > 0) & (subevent < 10)){ //string event 01 tm 09
   SPreadByte( inbyte);      //inbyte is lengteveld  
   for (int j = inbyte;j>0;j--){ 
    SPreadChar( inchar);     //string 
    mididata += inchar;
   } 
   return;
  }else{
   SPreadByte( inbyte);         //lengteveld  
   for (int k = inbyte;k>0;k--){  //byte1 is lengteveld
    SPreadChar(inchar);         //skip data 
   } 
   return; 
  }  
 }else{                        //non meta-events
  eventkaal = event & 0xF0;    //verwijder channel
  switch (eventkaal){
  case 0x80:            //noteoff
   data1 = byte1;       //al ingelezen
   SPreadByte( data2);  
   return;
  case 0x90:            //noteon of noteoff
   data1 = byte1;       //al ingelezen
   SPreadByte( data2);  
   return; 
  case 0xA0:             //polyphone aftertouch
   mididata = "polyphone aftertouch"; 
   data1 = byte1;        //al ingelezen
   SPreadByte( data2); 
   return;
  case 0xB0:             //control change
   mididata = "control change"; 
   data1 = byte1;        //al ingelezen
   SPreadByte( data2); 
   return;
  case 0xC0:             //program change
   mididata = "program change"; 
   data1 = byte1;        //al ingelezen
   break;
  case 0xD0:             //channel aftertouch
   mididata = "channel aftertouch"; 
   data1 = byte1;        //al ingelezen
   return;
  case 0xE0:             //pitch bend
   mididata = "pich bend"; 
   data1 = byte1;        //al ingelezen
   SPreadByte( data2); 
   return;
  } 
  if (event == 0xF0){    //sysex
   mididata = "Sysex"; 
   inbyte = data1;       //al ingelezen
   while (true){
    if (inbyte == 0xF7){
     return;
    }
    SPreadByte( inbyte);   //skip alle data 
   }
   if ((event == 0xF1) | (event == 0xF3)){
    //                    //geen data
    return;
   }
    if ((event == 0xF2) | (event == 0xF30)){
    //                    //data1 al ingelezen, skip
    SPreadByte( inbyte);   //skip data2
    return;
   }
  } 
 }
}                                  


void PrintmidifileSP(String filenaam, String(swnotes)){ 
 long delta = 0;
 byte event = 0;
 byte subevent = 0;
 byte data1 = 0;  
 byte data2 = 0;
 String mididata = "";
 byte eventkaal = 0;
 long noteons = 0;
 long noteoffs = 0;
 long deltatot = 0;
 MidiOpenfileprintSP(filenaam);
 Serial.print(filenaam);
 if (MidiPrtSPstatus == 8) {
  Serial.println(", file open error");
  return;
 } 
 Serial.println(", file size: " + String(MidiPrtSPfilesize));
 if (MidiPrtSPstatus == 2) {
  Serial.println("Geen Midi-file");
  return;
 } 
 if (MidiPrtSPstatus == 3) {
  Serial.println("Geen format 0 of 1");
  return;
 } 
 Serial.println("Format: " + String(MidiPrtSPformat));
 Serial.println("Aantal tracks: "+ String(MidiPrtSPaanttracks)); 
 Serial.println("Ticksperkwart "+ String(MidiPrtSPticksperkwart));    
 for (int t=0;t<MidiPrtSPaanttracks;t++){
  Serial.println("track"+ String(t) + " "+ MidiPrtSPtrackleng[t]); 
 }
 for(int trk=0;trk<MidiPrtSPaanttracks;trk++){ 
  Serial.println("Start track "+ String(trk) 
                 + " lengte "+ String(MidiPrtSPtrackleng[trk]));
  noteons = 0;
  noteoffs = 0;
  deltatot = 0; 
 while (true){
  MidiReadeventprintSP(trk,delta,event,subevent, data1,data2, mididata);
  if (MidiPrtSPstatus == 5){
   Serial.print("noteons " + String(noteons)); 
   Serial.print ("  noteoffs " + String(noteoffs)); 
   Serial.println (" ticks " + String(deltatot)); 
   Serial.println("End of track "+ String(trk));
   break;    
  }
  if (MidiPrtSPstatus == 7){
   Serial.println("Stuctuurfout in bestand"); 
   return;    
  }
  deltatot += delta;
  eventkaal = event & 0XF0;
  if ((event == 0xFF) & (subevent == 0x2F)){   //EOT
   break; 
  }
   if (eventkaal == 0x80){
   if (swnotes == "1") {
    Serial.println("noteoff "+ String(data1) + ","+ String(delta));
   }
   noteoffs++;
   goto nextevent;
  }
  if (eventkaal == 0x90){
   if (data2 == 0){
    if (swnotes == "1") {
     Serial.println("noteoff "+ String(data1) + ","+ String(delta)); 
    } 
    noteoffs++;
   }else{
    if (swnotes == "1") {
     Serial.println("noteon "+ String(data1) + ","+ String(delta)); 
    } 
    noteons++;
    }
    goto nextevent;
   }  
   Serial.print(event,HEX);
   if ((event == 0xFF) & (subevent != 0)){
    if (subevent < 16){
     Serial.print("0");  //voorloop 0
    }
    Serial.print(subevent,HEX);
    Serial.print(" "+ mididata);
    if (subevent == 0x51){
     Serial.print(" "+ String(MidiPrtSPtempo));
     Serial.println(", mspertick "+ String(MidiPrtSPmspertick));
    }else{ 
     Serial.println();
    }
   }else{
    Serial.println(" "+ mididata);
   }
nextevent: 
 data1 = data1;  //dummy instructie tbv label
 } //end while
} //end for
 
 SPclosefile();
}
                                         
