                                            
void MidiOpenfileread(String filenaam){
 // Open midifile
 //String filenm = "/"+ filenaam;
 String filenm = filenaam;
 String trackhead = ""; 
 char   inchar ;
 long   trackadres = 0;
 Midistatus = 0;
 SDopenfileread(0,filenm);
 if (SDfilestatus[0] != 1) {  
  Midistatus = 8;
  return;
 }
 Midifilesize =  SDfilesize(0);
 SDseek(0,14);   //MTrk
 for (int i = 0;i<4;i++){ 
  SDreadChar(0,inchar);
  trackhead += inchar;
 }
 if (trackhead != "MTrk") {
  Midistatus = 2;          //geen trackheader, geen midi
  return;
 }  
 SDseek(0,8);              //format 
 SDreadIntDOS(0,Midiformat);
 SDseek(0,10);            //aantal tracks 
 SDreadIntDOS(0,Midiaanttracks);
 if ((Midiformat != 0) && (Midiformat != 1)){
  Midistatus = 3;         //geen format 0 of  1
  return;  
 }    
 SDseek(0,12);            //ticksperkwart 
 SDreadIntDOS(0,Miditicksperkwart);
 trackadres = 14;         //eerste track, vast adres
 for (int t=0;t<Midiaanttracks;t++){
  Miditrackadres[t] = trackadres; 
  SDseek(0,trackadres);    //positioneer op track
  trackhead = "";
  for (int i=0;i<4;i++){   //MTrk
   SDreadChar(0,inchar);
   trackhead += inchar;
  }
  if (trackhead != "MTrk") {
   Midistatus = 2;         //volgend track geen trackheader
   return;
  }else{
   SDreadLongDOS(0,Miditrackleng[t]);
  }  
  trackadres += (Miditrackleng[t]);  //volgende track
  trackadres += 8;  //lengte is excl MTrk en lengteveld
  Midiposition[t] = Miditrackadres[t] + 8;
  Mididelta[t] = 0;
  Midiswfirst = 0;
 } 
 Midilastevent = 0;
 Midistatus = 1; 
}


void Getdelta(int tracknr){
 byte inbyte = 0; 
 long delta = 0;
 if (Mididelta[tracknr] == 999999){ //track al op EOT
  return;
 }
 SDreadByte(0,inbyte);     //lees deltatime 1 tot 4 bytes (mod128)
 if (inbyte < 128){
  delta = delta + inbyte;     //1e byte, klaar
 }else{
  delta = delta + (inbyte -128);
  delta = delta * 128; 
  SDreadByte(0, inbyte);
  if (inbyte < 128){
   delta = delta + inbyte;    //2e byte, klaar
  }else{
   delta = delta + (inbyte -128);
   delta = delta * 128; 
   SDreadByte(0, inbyte);
   if (inbyte < 128){
    delta = delta + inbyte;   //3e byte, klaar
   }else{
    delta = delta + (inbyte -128);
    delta = delta * 128; 
    SDreadByte(0, inbyte);
    if (delta < 128){         //4e moet laag zijn
     delta = delta + inbyte;  //4e byte, klaar
    }else{
     Midistatus = 7;          //structuur error
    }
   }
  }
 } 
 Mididelta[tracknr]= Mididelta[tracknr]+ delta;
 Midiposition[tracknr] = SDposition(0);
}

void Verminderdeltas(int tr){
 long curdelta = Mididelta[tr]; 
 for (int t=0;t<Midiaanttracks;t++){
  if (Mididelta[t] != 999999){
   Mididelta[t] = Mididelta[t] - curdelta;
   //Serial.println(" = "+ String(Mididelta[t])); 
  }
 }  
}

void Zoekcurtrack(int &curtrack){
 long delta = 9999999; 
 if (Midiformat == 0){return;}  //altijd 0
 curtrack = 0;              
 for (int tr=0;tr<Midiaanttracks;tr++){ //zoek welke track aan de beurt is
  if (Mididelta[tr] < delta){ //deze delta kleiner dan vorige
   delta = Mididelta[tr]; 
   curtrack = tr;            //track met event dat aan de beurt is
  }
 } 
 //Serial.println("zoekcurtrack " + String(curtrack));   
}

void CheckEOF(){
 byte all999 = 1; 
 for (int tra=0;tra<Midiaanttracks;tra++){ 
  if (Mididelta[tra] != 999999){ //track op EOT?
   all999 = 0;                   //deze track nog niet op EOT
  }
 }
 if (all999 == 1){              //alle tracks afgehandeld, EOF
  Midistatus = 5;
 }  
}



void MidiReadfilenote(long &deltams, String &soort, 
                 int &nootnr, byte &track, byte &channel, byte &velocity){
// Lees midinote-event
 char   inchar;
 byte   inbyte; 
 byte   byte1 = 0;
 byte   data1 = 0;
 byte   data2 = 0;
 long   inlong = 0;
 byte   event = 0;
 byte   subevent = 0;
 byte   eventkaal = 0;
 int    curtrack = 0;
 if (Midiswfirst == 0){
  Midiswfirst = 1;
  Midistatus = 1;
  for (int tr=0;tr<Midiaanttracks;tr++){
   Midiposition[tr] = Miditrackadres[tr]+8; //start of track data
   Mididelta[tr] = 0; 
   SDseek(0, Midiposition[tr]); //alle tracks op pos van eerste data
   Getdelta(tr);                //eerste delta's van alle tracks
  }
 }
 while(true){                   //behandel tempo en  notes, skip rest 
  CheckEOF();
  if (Midistatus == 5){return;} //EOF
  Zoekcurtrack(curtrack);       //curtrack met laagste delta
  SDseek(0,Midiposition[curtrack]); 
  SDreadByte(0, inbyte);       //eventbyte of indicatie running
  if (inbyte < 128){           //running status
   byte1 = inbyte;             //byte 1 van message
   event = Midilastevent;      //gebruik vorige event
  }else{
   event = inbyte;             //event ingelezen
   Midilastevent = event;      //save voor running status
   SDreadByte(0, byte1);       //lees byte 1 van message
  }
  if (event == 255){           //hex FF, meta-event 
   subevent = byte1;           //byte1 is metadatacode 
   if (subevent == 0x2F){      //EOT
    Mididelta[curtrack] = 999999; //end of track

   } 
   if (subevent == 0x51){      //tempo
    SDreadByte(0, inbyte);     //lengteveld
    SDreadLong3DOS(0,inlong);  //3bytes tempo (little endian)
    Miditempo = inlong;        //long to float 
    //Serial.println("tempo " + String(Miditempo));
    Midimspertick = Miditempo / 1000 / Miditicksperkwart;
    //Serial.println("mspertick="+ String( Midimspertick));
    Getdelta(curtrack);       //delta en position van volgende event 
   }else{   
    SDreadByte(0, inbyte);          //lengteveld  
    for (int k = inbyte;k>0;k--){   //byte1 is lengteveld
     SDreadChar(0,inchar);          //skip data 
    } 
    //Serial.print(event, HEX); Serial.println (subevent, HEX); 
    Getdelta(curtrack);       //delta en position van volgende event 
   }
  }else{                      //non meta-events
   eventkaal = event & 0xF0;  //verwijder channel
   switch (eventkaal){
   case 0x80:                 //noteoff
    nootnr = byte1;           //al ingelezen
    SDreadByte(0, velocity);  
    channel = event & 0x0F;   //0 tm 15
    track = curtrack;
    soort = "E";              //noteoff
    //Serial.println(event, HEX); 
    deltams = Mididelta[curtrack]* Midimspertick; //gecumuleerde delta
    Verminderdeltas(curtrack); //van alle trks delta's aftrekken 
    Getdelta(curtrack);       //delta en position van volgende event 
    return;                   //klaar, return note
   case 0x90:                 //noteon of noteoff
    nootnr = byte1;           //al ingelezen
    SDreadByte(0, velocity);  
    channel = event & 0x0F;  //0 tm 15
    track = curtrack;
    if (velocity == 0){      //velocity 0 is noteoff
     soort = "E";            //noteoff
    }else{
     soort = "B";            //noteon
    }
    //Serial.println(event, HEX); 
    deltams = Mididelta[curtrack]* Midimspertick; //gecumuleerde delta
    Verminderdeltas(curtrack); //van alle trks delta's aftrekken 
    Getdelta(curtrack);      //delta en position van volgend event 
    return;                  //klaar, return note
   case 0xA0:                //skip
    SDreadByte(0, data2); 
    Getdelta(curtrack);      //cumuleer delta
    break;
   case 0xB0:                //skip
    SDreadByte(0, data2); 
     //Serial.println(event, HEX); 
    Getdelta(curtrack);      //cumuleer delta
    break;
   case 0xC0:                //skip
    //Serial.println(event, HEX); 
    Getdelta(curtrack);      //cumuleer delta
    break;
   case 0xD0:                //skip
    //Serial.println(event, HEX); 
    Getdelta(curtrack);      //cumuleer delta
    break;
   case 0xE0:                //skip
    //Serial.println(event, HEX); 
    SDreadByte(0, data2);
    Getdelta(curtrack);      //cumuleer delta 
    break;
   } 
   if (event == 0xF0){       //sysex
    inbyte = data1;          //al ingelezen
    while (true){
     if (inbyte == 0xF7){    //skip
      break;
     }
     SDreadByte(0, inbyte);  //skip alle data 
    }
     //Serial.println(event, HEX); 
    Getdelta(curtrack);      //cumuleer delta
   }
   if ((event == 0xF2) | (event == 0xF30)){ //skip
    SDreadByte(0, inbyte);   //skip data2
     //Serial.println(event, HEX); 
    Getdelta(curtrack);      //cumuleer delta
   }
  }  //volgende event (while)
 }
}     
