#ifdef ESP32
 #include <SD.h>                   //SD-kaart library
#endif
#ifdef ESP8266
 #include <SD.h>                   //SD-kaart library
#endif
#ifdef AVR
 #include <SdFat.h>                 //SD-kaart library
 SdFat SD;
#endif

File   SDdir ;           //handle voor open dir
File   SDcreat;          //handle voor create file
#define aantfiles 5      //handles voor files 0tm4
File   SDf[aantfiles];   //handles voor files 
long   SDfileinx = 0;

// SD-kaart routines
//------------------
void SDinitunit() {             //initialiseer SD-unit
 SDdirstatus = 0;
 for (int i=0;i<aantfiles;i++){
  SDfilestatus[i] = 0;        //reset alle files
 }
 pinMode(SDCSpin, OUTPUT);
 if (SD.begin(SDCSpin)) {
  SDunitstatus = 1;
 }else{
  SDunitstatus = 9;
 }
}

#ifdef ESP32
 #define ESP
#endif
#ifdef ESP8266
 #define ESP
#endif


#ifdef ESP     //ESP32 en ESP8266
void SDopenDirectory(String dir, String extensie) {
 // lees alle filenames in de directory en sla op in array SDfilenaam. 
 String filenaam = "";
 String curdir = "/"+ dir;
 String removedir = "";
 String ext  = extensie;
 ext.toUpperCase();
 String fil= "";
 int swselectfile = 0;
 if (dir == ""){
  removedir = "/";
 }else{
  removedir = "/"+ dir + "/";
 }
 SDinitunit();
 if (SDunitstatus != 1){
  SDdirstatus = 9;
  return;
 }
 const char* fileentry ;
 SDdir = SD.open(curdir);
 if (SDdir){
  SDdirstatus = 1; 
 }  
 SDfilecount = 0;
 SDdircount = 0;
 SDfileinx = 0;
 for (int i=1;i<=SDfilemax;i++){  
  SDfilenaam[i] = ""; 
 } 
 while (true) {
  File entry =  SDdir.openNextFile();
  fileentry = entry.name();
  if (! entry) {     //geen entries meer, klaar
   break; // end of file
  }
  if (SDfileinx == SDfilemax){  //indexen begint met 1
   SDdirstatus = 2;   //Open OK, maar teveel files in dir
   return;
  }
  if (entry.isDirectory()) { //geen subdirs openen
   SDfileinx ++;
   SDdircount ++;
   filenaam = fileentry;
   filenaam.replace(removedir ,"");  
   SDfilenaam[SDfileinx] = "/"+ filenaam;
  }else{
   fil = fileentry;
   fil.toUpperCase();
   if (extensie ==""){
    swselectfile = 1;
   }else{
    if (fil.indexOf(ext)> -1){
     swselectfile = 1;
    }else{
     swselectfile = 0;
    }
   }
   if (swselectfile == 1){
    SDfileinx ++;
    SDfilecount ++;
    filenaam = fileentry;
    filenaam.replace(removedir,"");  
    SDfilenaam[SDfileinx] = filenaam;
    if (SDfilenaam[SDfileinx] == filenaam){ 
    }else{                //plaatsen in array mislukt
     SDdirstatus = 3;     //Out of memory, namen in dir te lang, array vol
     return;
    }
    if (SDfilenaam[SDfileinx] == ""){  //plaatsen in array mislukt               
     SDdirstatus = 3;     //Out of memory, namen in dir te lang, array vol
     return;
    }
    //Serial.println(fileentry);
    //Serial.print(SDfileinx); Serial.print(" ");  Serial.println(SDfilenaam[SDfileinx]);
   }
  }
  entry.close();
 }
}
#endif
#ifdef AVR
void SDopenDirectory(String dirname, String extensie) {
 // lees alle filenames in de directory en sla op in array SDfilenaam. 
 String dir = "/"+ dirname;
 int swselectfile = 0;
 String ext  = extensie;
 ext.toUpperCase();
 String fil= "";
 SDinitunit();
 if (SDunitstatus != 1){
  SDdirstatus = 9;
  return;
 }
 char fileentry[255];  //entry uit root, dir of file
 SDdir = SD.open(dir);
 if (SDdir){
  SDdirstatus = 1; 
 }  
 SDfilecount = 0;
 SDdircount = 0;
 SDfileinx = 0;
 for (int i=0;i<=SDfilemax;i++){  
  SDfilenaam[i] = ""; 
 }  
 while (true) {
  File entry =  SDdir.openNextFile();
  entry.getName(fileentry, sizeof(fileentry));
  if (! entry) {     //geen entries meer, klaar
   break; // end of file
  }
  if (SDfileinx == SDfilemax){  //indexen begint met 1
   SDdirstatus = 2;   //Open OK, maar teveel files in dir
   return;
  }
  if (entry.isDirectory()) {
   SDfileinx ++;
   SDdircount ++;
   String hulp = "/"; 
   SDfilenaam[SDfileinx] = hulp + fileentry;
   //Serial.println(SDfilenaam[SDfileinx]);
  }else{
   fil = fileentry;
   fil.toUpperCase();
   if (extensie == ""){
    swselectfile = 1;
   }else{
    if (fil.indexOf(ext)> -1){
     swselectfile = 1;
    }else{
     swselectfile = 0;
    }
   }
   if (swselectfile == 1){
    SDfileinx ++;
    SDfilecount ++;
    SDfilenaam[SDfileinx] = fileentry;
    if (SDfilenaam[SDfileinx] == fileentry){ 
    }else{                //plaatsen in array mislukt
     SDdirstatus = 3;     //Out of memory, namen in dir te lang, array vol
     return;
    }
    if (SDfilenaam[SDfileinx] == ""){  //plaatsen in array mislukt               
     SDdirstatus = 3;     //Out of memory, namen in dir te lang, array vol
     return;
    }
    //Serial.println(fileentry);
    //Serial.print(SDfileinx); Serial.print(" ");  Serial.println(SDfilenaam[SDfileinx]);
   }
  }
  entry.close();
 }
}
#endif

void SDprintdirentries(String dir){
 // Print directory met subdirs (recursieve call)
 int lasti = 0;
 String lastdir = "";
 String filenaam = "";
 SDopenDirectory(dir, "");
 Sortstring(SDfilenaam, 1, SDfilecount+SDdircount,0);
 for (int i = 1; i <= SDfilecount+SDdircount; i++) {
  for (int j=0; j<SDdirlevel; j++){
   Serial.print("   ");  //inspringen
  }
  filenaam = SDfilenaam[i];
  Serial.println("   "+ filenaam);
  if (SDfilenaam[i].startsWith("/")){   //subdirs werkt niet PP (crash)
   //lasti = i;                         //nog in orde maken
   //lastdir = dir; 
   //SDdirlevel++;
   //SDprintdirentries(dir + SDfilenaam[i]);
   //SDopenDirectory(dir,"");
   //Sortstring(SDfilenaam, 1, SDfilecount+SDdircount,0);
   //SDdirlevel--;
   //i = lasti;
   //dir = lastdir; 
  }
 } 
}

void SDcreatefile(String filenm){
 //Maak een lege file aan. Als deze al bestand wordt deze eerst
 //deleted
 String filenaam = "/"+ filenm;
 SDinitunit();
 if (SDunitstatus != 1){
  return;
 }
 if (SD.exists(filenaam.c_str())) {
  SD.remove(filenaam.c_str());
 }
 SDcreat = SD.open(filenaam, FILE_WRITE);
 SDcreat.close();

}
void SDdeletefile(String filenm){
 //Delete file
 String filenaam = "/"+ filenm;
 SD.remove(filenaam.c_str());
}
void SDseek(int fnr, long positie){
 //zet positie van volgende IO
 //NB, de eerste byte in de file is 0
 SDf[fnr].seek(positie);
}
long SDfilesize(int fnr){
 //returns file size van open file
 return SDf[fnr].size();
}
long SDposition(int fnr){
 //returns fileposition van open file,
 //dat is het nummer van de volgende IO
 //NB, de eerste byte in de file is 0
 return SDf[fnr].position();
}
bool SDavailable(int fnr){
 //returns availability van open file
 return SDf[fnr].available();
}
void SDopenfileread(int fnr, String filenm){
 //open file voor lezen 
 String filenaam = "/"+ filenm;
 SDinitunit();
 if (SDunitstatus != 1){
  SDfilestatus[fnr] = 9;
  return;
 }
 if (filenaam == ""){
  SDfilestatus[fnr] = 8;
  return;
 } 
 if (!SD.exists(filenaam.c_str())) {
  SDfilestatus[fnr] = 8;
  return;
 }
 SDf[fnr] = SD.open(filenaam);
 if (SDf[fnr]) {
  SDfilestatus[fnr] = 1;
 }else{
  SDfilestatus[fnr] = 8;
 }
}
void SDopenwrite(int fnr, String filenm){
 //Open file voor write. Als de file niet bestond
 //wordt een lege aangemaakt.
 String filenaam = "/"+ filenm;
 if (SDunitstatus != 1){
  SDfilestatus[fnr] = 9;
  return;
 }
 if (filenaam == ""){
  SDfilestatus[fnr] = 8;
  return;
 } 
 if (SD.exists(filenaam.c_str())) {
  SD.remove(filenaam.c_str());
 }
 SDf[fnr] = SD.open(filenaam, FILE_WRITE);
 if (SDf[fnr]) {
  SDfilestatus[fnr] = 2;
 }else{
  SDfilestatus[fnr] = 8;
 }
}
void SDopenappend(int fnr, String filenm){
 //Open file voor append. De hierna geschreven data
 //wordt achteraan toegevoegd.  
 String filenaam = "/"+ filenm;
 if (SDunitstatus != 1){
  SDfilestatus[fnr] = 9;
  return;
 }
 if (filenaam == ""){
  SDfilestatus[fnr] = 8;
  return;
 } 
 #ifdef ESP    //ESP32 en ESP8266
  SDf[fnr] = SD.open(filenaam, FILE_APPEND);
 #endif
 #ifdef AVR
  SDf[fnr] = SD.open(filenaam,  O_APPEND|O_WRITE);
 #endif
 if (SDf[fnr]) {
  SDfilestatus[fnr] = 2;
 }else{
  SDfilestatus[fnr] = 8;
 }
}

void SDreadline(int fnr, String &record){
 //lees een lijn, alleen asci chars, CR is end of line 
 if (SDfilestatus[fnr] != 1){
  return;
 }
 record = "";
 while (SDf[fnr].available()) { //tot end of file
  char Inbyte = SDf[fnr].read();
  if (Inbyte == '\r') {       //CR is end of record
   return;                    //record gelezen
  }else{ 
   if (Inbyte > 31) {         //asci character
    //SDrecord += Inbyte;     //byte in record
    record += Inbyte;         //byte in record
   }                          //en leees volgende
  }  
 }
 SDf[fnr].close();
 SDfilestatus[fnr] = 5;            //end of file
}

void SDprintline(int fnr, String line){
 //Schrijf een line, beeindigd met CRLF 
 SDf[fnr].println(line);
}


void SDreadByte(int fnr, byte &databyte){
 databyte = SDf[fnr].read();      
}
void SDreadChar(int fnr, char &databyte){
 databyte = SDf[fnr].read();      
}
void SDreadInt(int fnr, int &dataint){
  int i2 = SDf[fnr].read();    //low order (big endian)
  int i1 = SDf[fnr].read();    //high order
  dataint = ((i2 << 0) & 0xFF) + ((i1 << 8) & 0xFFFF);
}
void SDreadIntDOS(int fnr, int &dataint){
  int i1 = SDf[fnr].read();    //high order (little endian)
  int i2 = SDf[fnr].read();    //low order
  dataint = ((i2 << 0) & 0xFF) + ((i1 << 8) & 0xFFFF);
}
void SDreadLong(int fnr, long &datalong){
 long l4 = SDf[fnr].read();   //low order (big endian)
 long l3 = SDf[fnr].read();
 long l2 = SDf[fnr].read();
 long l1 = SDf[fnr].read();   //high order
 datalong = ((l4 << 0) & 0xFF) + ((l3 << 8) & 0xFFFF)
          + ((l2 << 16) & 0xFFFFFF) + ((l1 << 24) & 0xFFFFFFFF);        
}
void SDreadLongDOS(int fnr, long &datalong){
 long l1 = SDf[fnr].read();   //high order  (little endian)
 long l2 = SDf[fnr].read();
 long l3 = SDf[fnr].read();
 long l4 = SDf[fnr].read();   //low order
 datalong = ((l4 << 0) & 0xFF) + ((l3 << 8) & 0xFFFF)
          + ((l2 << 16) & 0xFFFFFF) + ((l1 << 24) & 0xFFFFFFFF);        
}
void SDreadLong3DOS(int fnr, long &datalong){
 long l1 = SDf[fnr].read();   //high order  (3 bytes little endian)
 long l2 = SDf[fnr].read();
 long l3 = SDf[fnr].read();   //low order
 datalong = ((l3 << 0) & 0xFF) + ((l2 << 8) & 0xFFFF)
          + ((l1 << 16) & 0xFFFFFF) ;        
}
  
void SDwriteByte(int fnr, byte databyte){
 SDf[fnr].write(databyte);      
}
void SDwriteChar(int fnr, char databyte){
 SDf[fnr].write(databyte);      
}

void SDwriteInt(int fnr, int dataint){
 byte b2 = (dataint & 0xFF);         //low order 
 byte b1 = ((dataint >> 8) & 0xFF);  //high order
 SDf[fnr].write(b2);  //low order (big endian)
 SDf[fnr].write(b1);  //high order
}
void SDwriteIntDOS(int fnr, int dataint){
 byte b1 = (dataint & 0xFF);         //low order (big endian)
 byte b2 = ((dataint >> 8) & 0xFF);  //high order
 SDf[fnr].write(b2);  //high order (little endian)
 SDf[fnr].write(b1);  //low order
}
void SDwriteLong(int fnr, long datalong){
 byte b4 = (datalong & 0xFF);         //low order 
 byte b3 = ((datalong >> 8) & 0xFF);
 byte b2 = ((datalong >> 16) & 0xFF);
 byte b1 = ((datalong >> 24) & 0xFF); //high order
 SDf[fnr].write(b4);  //low order (big endian)
 SDf[fnr].write(b3);
 SDf[fnr].write(b2);
 SDf[fnr].write(b1);  //high order
}
void SDwriteLongDOS(int fnr, long datalong){
 byte b1 = (datalong & 0xFF);         //low order 
 byte b2 = ((datalong >> 8) & 0xFF);
 byte b3 = ((datalong >> 16) & 0xFF);
 byte b4 = ((datalong >> 24) & 0xFF); //high order
 SDf[fnr].write(b4);  //high order (little endian)
 SDf[fnr].write(b3);
 SDf[fnr].write(b2);
 SDf[fnr].write(b1);  //low order
}
void SDclosefile(int fnr){
 //close file
 //NB: als je na schijven geen close doet wordt de filesize niet
 //    bijgewerkt en gaan de schfijfopdrachten verloren.
 //    Zowel bij write als append.
 SDf[fnr].close();
 SDfilestatus[fnr] = 0; 
}

